<?php
namespace Teknisa\EST\Modules\Ajuste\Services;

use Teknisa\EST\Services\ValidacoesEstoqueService;
use Teknisa\EST\Modules\Ajuste\Factories\LanctoestoqAjusteFactory;
use \Estoque\Entities\Lanctoestoq;
use \Estoque\Entities\Itlanctoest;

class ItlanctoestProdutoService{

	protected $dataSourceName = "lanctoestoq_ajuste";
	
    protected $validacoesEstoqueService;
    protected $environment;

    public function __construct (
        ValidacoesEstoqueService $validacoesEstoqueService,
        $entityManager,
        $environment
    )
    {
        $this->validacoesEstoqueService = $validacoesEstoqueService;
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }
    
    public function deleteItem($cdfilial,$nrlancestq,$nrsequitem) {
        try {
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            $factory = new LanctoestoqAjusteFactory($this->entityManager);
            
            $nrorg = $this->environment->getNrOrgTrab();
          
            
            
            //parte que confere relacionamentos de ajuste com retiradas.
            //retirada por setor 
         
            $retiradasSetor = $factory->getRetiradaSetor($cdfilial, $nrlancestq);
            foreach($retiradasSetor as $retSet){
                $itensReti = Itlanctoest::findByCdfilialAndNrlancestqAndNrorg(
                    $retSet['CDFILIALRET'], $retSet['NRLANCESTRET'], $nrorg
                );
                
                $lancamentoReti = Lanctoestoq::findOneByCdfilialAndNrlancestqAndNrorg(
                    $retSet['CDFILIALRET'], $retSet['NRLANCESTRET'], $nrorg
                );
               
                foreach($itensReti as $item){
                    $this->entityManager->remove($item);
                    $this->entityManager->flush($item);
                    if($item->getIdevolestoq() =='S')
                        $this->validacoesEstoqueService->atualizaEstoque($retSet['CDFILIALRET'], $retSet['NRLANCESTRET'],true,$item->getNrsequitem());
                }
                
            }
             
            
            //retiradas por serviço
            $retiradasServico = $factory->getRetiradaServico($cdfilial, $nrlancestq);
            foreach($retiradasServico as $retSer){
                $itensReti = Itlanctoest::findByCdfilialAndNrlancestqAndNrorg(
                    $retSer['CDFILIALRET'], $retSer['NRLANCESTRET'], $nrorg
                );
                
                $lancamentoReti = Lanctoestoq::findOneByCdfilialAndNrlancestqAndNrorg(
                    $retSer['CDFILIALRET'], $retSer['NRLANCESTRET'], $nrorg
                );
    
                foreach($itensReti as $item){
                    $factory->deleteItemReti($retSer['CDFILIALRET'], $retSer['NRRETIRADA'], $retSer['NRCARDAPIO'], $item->getNrsequitem(), $item->getCdproduto());
                    
                    $this->entityManager->remove($item);
                    $this->entityManager->flush($item);
                    if($item->getIdevolestoq() =='S')
                        $this->validacoesEstoqueService->atualizaEstoque($retSer['CDFILIALRET'], $retSer['NRLANCESTRET'],true,$item->getNrsequitem());
                }
            }
            
            $item = Itlanctoest::findOneByCdfilialAndNrlancestqAndNrsequitemAndNrorg($cdfilial, $nrlancestq,$nrsequitem, $nrorg);
            
            $this->entityManager->remove($item);
            $this->entityManager->flush($item);
            if($item->getIdevolestoq() =='S'){
                $this->validacoesEstoqueService->atualizaEstoque($cdfilial,$nrlancestq,true,$nrsequitem);
            }
            
            $connection->commit();
		} catch (\Exception $e) {
		    $connection->rollback();
			throw $e;
		}
	}

}