CREATE OR REPLACE
TRIGGER USR_BLOQ_PARAMPRODSUP BEFORE INSERT ON PARAMPRODSUP
FOR EACH ROW
DECLARE
   V_CDGRUPPROD    VARCHAR2(10);
   V_CDSUBGRPROD   VARCHAR2(10);
   V_CDFILIOPELOG  VARCHAR2(4);
   V_CDARVPROD     VARCHAR2(80);
   V_NMFILIAL      VARCHAR2(40);
BEGIN
   SELECT NVL(MAX(CDGRUPPROD), 'X')
     INTO V_CDGRUPPROD
     FROM PARASUPRI
    WHERE CDFILIAL = '0003';

   IF V_CDGRUPPROD <> 'X' THEN
      IF (:NEW.CDSUBGRPROD  <> LPAD(:NEW.CDFILIOPELOG, 10, '0')) THEN
         SELECT MAX(:NEW.CDFILIAL||' - '||NMFILIAL)
           INTO V_NMFILIAL
          FROM FILIAL
         WHERE CDFILIAL = :NEW.CDFILIAL; 
         SELECT MAX(CDARVPROD||'-'||NMPRODUTO)
           INTO V_CDARVPROD
           FROM PRODUTO
          WHERE CDPRODUTO = :NEW.CDPRODUTO;
         RAISE_APPLICATION_ERROR(-20501, 'Operao bloqueada! Item '||V_CDARVPROD ||' no pode ser parametrizado para o OL: '||:NEW.CDFILIOPELOG ||' no subgrupo:'||:NEW.CDSUBGRPROD|| ' para a filial: '||V_NMFILIAL||'.', True);
      END IF;
      SELECT NVL(MAX(CDFILIOPELOG), 'X'), NVL(MAX(CDSUBGRPROD), 'X')
        INTO V_CDFILIOPELOG, V_CDSUBGRPROD
        FROM PARAMPRODSUP
       WHERE CDGRUPPROD   = :NEW.CDGRUPPROD
         AND CDFILIOPELOG IS NOT NULL
         AND CDFILIAL     = :NEW.CDFILIAL
         AND CDPRODUTO    = :NEW.CDPRODUTO
         AND NRSEQPARPROD <> :NEW.NRSEQPARPROD
         AND (CDSUBGRPROD  <> LPAD(:NEW.CDFILIOPELOG, 10, '0') OR CDFILIOPELOG <> :NEW.CDFILIOPELOG);
      
      IF ((V_CDFILIOPELOG <> 'X') OR (V_CDSUBGRPROD <> 'X')) THEN
         SELECT MAX(:NEW.CDFILIAL||' - '||NMFILIAL)
           INTO V_NMFILIAL
          FROM FILIAL
         WHERE CDFILIAL = :NEW.CDFILIAL; 
         SELECT MAX(CDARVPROD||'-'||NMPRODUTO)
           INTO V_CDARVPROD
           FROM PRODUTO
          WHERE CDPRODUTO = :NEW.CDPRODUTO;
         RAISE_APPLICATION_ERROR(-20501, 'Operao bloqueada! Item '||V_CDARVPROD ||' j parametrizado para o OL: '||CASE V_CDFILIOPELOG
                                                                                                                        WHEN 'X'
                                                                                                                        THEN :NEW.CDFILIOPELOG
                                                                                                                        ELSE V_CDFILIOPELOG
                                                                                                                     END||' no subgrupo:'||CASE V_CDSUBGRPROD
                                                                                                                                              WHEN 'X'
                                                                                                                                              THEN :NEW.CDSUBGRPROD
                                                                                                                                              ELSE V_CDSUBGRPROD
                                                                                                                                           END|| ' para a filial: '||V_NMFILIAL||'.', True);
      END IF;
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('USR_BLOQ_PARAMPRODSUP','6.22.xxx'); END;
/
