function Est31100_PosicaoDeEstoque_Controller(ScreenService, General, templateManager, ProductField, ProdTreeGroup, localStorageEngine) {

	this.almoxarifadoOnChange = function(widget) {
		var currentRow = widget.currentRow;
		var localField = widget.getField("DSLOCALESTOQ");
		currentRow.DSLOCALESTOQ = null;
		if (currentRow.IDUTILLCESTQ == 'S') {
			currentRow.CDLOCALESTOQ = null;
			if (currentRow.CDALMOXARIFE) {
				localField.readOnly = false;
				localField.reload();
			}
			else {
				localField.readOnly = true;
			}
		}
	};

	this.changeFilter = function(widget) {
		var filterPopup = widget.appliedFilter.FILTER_ROW;
		var filtersArray = widget.dataSourceFilter.map(function(filter) {
			filter.operator = '=';
			filter.value = filterPopup[filter.name];
			return filter;
		});
		filtersArray.push({
			name: "DTPOSICAO",
			operator: "=",
			value: filterPopup.DTPOSICAO
		}, {
			name: "NMTIPOCUSTO",
			operator: "=",
			value: filterPopup.NMTIPOCUSTO
		});
		widget.dataSourceFilter = filtersArray;
		widget.getField("NMPRODUTO").grouped = filterPopup.IDUTILLOTE === 'S';
	};

	this.checkDataSourceData = function(widget) {
		var data = widget.dataSource.data;
		if (Array.isArray(data) && data.length === 0) {
			ScreenService.showMessage(ScreenService.i18n("Não há dados a serem listados."));
		}
	};

	this.produtoFinalIsValid = function(widget) {
		if (widget.currentRow.CDARVPRODFIN < widget.currentRow.CDARVPRODINI) {
			ScreenService.showMessage(ScreenService.i18n("Produto inicial deve ser menor ou igual ao produto final."));
			widget.currentRow.CDARVPRODFIN = null;
			widget.currentRow.NMPRODUTOFIN = null;
		}
	};

	this.produtoInicialIsValid = function(widget) {
		if (widget.currentRow.CDARVPRODFIN < widget.currentRow.CDARVPRODINI) {
			ScreenService.showMessage(ScreenService.i18n("Produto inicial deve ser menor ou igual ao produto final."));
			widget.currentRow.CDARVPRODINI = null;
			widget.currentRow.NMPRODUTOINI = null;
		}
	};

	this.setNivelData = (widget) => {

		let SetTime = setInterval((time) => {
			var levels = General.getLevelByMask("GER_CDPICTPROD", 1);
			var nivelField = widget.getField("NVTOT");
			var data = [];
			levels.forEach((level) => {
				data.push({ NVTOT: level.nivel });
			});
			nivelField.dataSource.data = data;

			widget.currentRow.NMRELATORIO = "EST31100";
			widget.currentRow.PAGE_BREAK = "S";
			widget.currentRow.ORDENANOME = "S";
			widget.currentRow.DATAPOS = getLocalVar("DTPROCESSA");

			this.getFilialLogada().then((success) => {
				widget.currentRow.CDFILIAL = success.dataset.filial_paramfilial_tipocusto[0].CDFILIAL;
				widget.currentRow.NMFILIAL = success.dataset.filial_paramfilial_tipocusto[0].NMFILIAL;
				widget.currentRow.CDTIPOCUSTO = success.dataset.filial_paramfilial_tipocusto[0].CDTIPOCUSTO;
				// widget.currentRow.NMTIPOCUSTO = success.dataset.filial_paramfilial_tipocusto[0].NMTIPOCUSTO;
				widget.currentRow.IDUTILALMOX = success.dataset.filial_paramfilial_tipocusto[0].IDUTILALMOX;
				widget.currentRow.IDUTILLCESTQ = success.dataset.filial_paramfilial_tipocusto[0].IDUTILLCESTQ;
				widget.currentRow.IDUTILLOTE = success.dataset.filial_paramfilial_tipocusto[0].IDUTILLOTE;
				this.relatorionOrUnidadeOnChange(widget);
				clearInterval(SetTime);
			});
		}, 2500);
	};

	this.getFilialLogada = function() {
		var filter = [
			{
				"name": "CDOPERADOR",
				"operator": "=",
				"value": "OPERADOR_LOGADO"
                },
			{
				"name": "CDFILIAL",
				"operator": "=",
				"value": "FILIAL_LOGADA"
				}

		    ];
		return General.callRestEngine('est_relatorios#/crud/filial_paramfilial_tipocusto', 'FilterData', filter);
	};

	this.toggleProdutoFinalReadonly = function(widget) {
		var produtoFinalField = widget.getField("NMPRODUTOFIN");
		produtoFinalField.readOnly = (widget.currentRow.CDARVPRODINI) ? false : true;
		widget.currentRow.CDARVPRODFIN = null;
		widget.currentRow.NMPRODUTOFIN = null;
	};

	this.relatorionOrUnidadeOnChange = function(widget) {
		var almoxField = widget.getField("DSALMOXARIFE");
		var localField = widget.getField("DSLOCALESTOQ");
		var flialField = widget.getField("NMFILIAL");
		var nomeRelatorio = widget.currentRow.NMRELATORIO;
		var currentRow = widget.currentRow;

		almoxField.setValue(null);
		localField.setValue(null);
		
		widget.currentRow.CDALMOXARIFE = null;
		widget.currentRow.CDLOCALESTOQ = null;

		widget.getField("PAGE_BREAK").readOnly = nomeRelatorio != "EST31100";
		
		widget.getAction('GERAR_PDF').isVisible = true;
		widget.getAction('GERAR_XLSX').isVisible = true;
		
		if(nomeRelatorio != 'EST31100CUSTO'){
			if(Array.isArray(flialField.value()))
				flialField.setValue(null);
		}

		if (nomeRelatorio == 'EST31100' || nomeRelatorio == 'EST31100CUSTO' || nomeRelatorio == 'EST31100CODEBAR' || nomeRelatorio == 'EST31104'|| nomeRelatorio == 'EST32800') {
			widget.getAction('GRID').isVisible = true;
			if(nomeRelatorio == 'EST31100CUSTO' || nomeRelatorio == 'EST31100CODEBAR' || nomeRelatorio == 'EST31104'){
				widget.getAction('GERAR_PDF').isVisible = false;
				widget.getAction('GERAR_XLSX').isVisible = false;
			}
		}
		
		
		else {
			widget.getAction('GRID').isVisible = false;
			if(nomeRelatorio == 'EST31100CUSTO'){
				widget.getAction('GERAR_PDF').isVisible = false;
				widget.getAction('GERAR_XLSX').isVisible = false;
			}
		}
		
		if (nomeRelatorio == 'EST31100CUSTO') {
			widget.getField('NMFILIALMULTI').isVisible = true;
			widget.getField('NMFILIAL').isVisible = false;
			widget.getField('NMGRUPFILI').isVisible = false;
			
			widget.getField('DSALMOXARIFEMULTI').isVisible = true;
			widget.getField('DSALMOXARIFE').isVisible = false;
			
			widget.getField('DSLOCALESTOQMULTI').isVisible = true;
			widget.getField('DSLOCALESTOQ').isVisible = false;
		} else {
			widget.getField('NMFILIALMULTI').isVisible = false;
			widget.getField('NMFILIAL').isVisible = true;
			
			widget.getField('DSALMOXARIFEMULTI').isVisible = false;
			widget.getField('DSALMOXARIFE').isVisible = true;
			
			widget.getField('DSLOCALESTOQMULTI').isVisible = false;
			widget.getField('DSLOCALESTOQ').isVisible = true;
		}

		// Array of Consolidated reports to manage filter fields
		let consolidatedReports = ['EST32800', 'EST32804', 'EST32808', 'EST32802'];

		if (consolidatedReports.includes(nomeRelatorio)) {
			delete(almoxField.validations);
			almoxField.readOnly = true;
			delete(localField.validations);
			localField.readOnly = true;
		}
		else {
			if (currentRow.CDFILIAL) {
				if (currentRow.IDUTILALMOX == 'S') {
					almoxField.validations = { "required": { "message": "Campo obrigatório" } };
					almoxField.readOnly = false;
					if (currentRow.IDUTILLCESTQ == 'S') {
						localField.validations = { "required": { "message": "Campo obrigatório" } };
						localField.readOnly = false;
					}
				}
				else {
					delete(almoxField.validations);
					almoxField.readOnly = true;
					delete(localField.validations);
					localField.readOnly = true;
				}
			}
			else {
				delete(almoxField.validations);
				almoxField.readOnly = true;
				delete(localField.validations);
				localField.readOnly = true;
			}
		}

		if (nomeRelatorio === 'EST32804' || nomeRelatorio === 'EST32808') {
			widget.getField('NMFILIAL').isVisible = false;
			widget.getField('NMGRUPFILI').isVisible = true;
			widget.currentRow.NMFILIAL = null;
			widget.currentRow.CDFILIAL = null;
		}
		else {
			if(nomeRelatorio != 'EST31100CUSTO')
				widget.getField('NMFILIAL').isVisible = true;
			widget.getField('NMGRUPFILI').isVisible = false;
			widget.currentRow.NMGRUPFILI = null;
			widget.currentRow.CDGRUPFILI = null;
		}
		widget.redraw();

		ProductField.updateProductFilters(widget);

	};

	this.validateFilterFields = function(currentRow) {
		if (currentRow.CDARVPRODFIN) {
			var cdarvprodfin = currentRow.CDARVPRODFIN;//.replace(/[^0-9]/g, '');
			var mascara = 20 - cdarvprodfin.length;
			currentRow.CDARVPRODFIN = currentRow.CDARVPRODFIN + 'z'.repeat(mascara).substring(0, mascara);
		}
		currentRow.DTPOSICAO = moment(currentRow.DATAPOS, 'DD/MM/YYYY').add(1, 'days').format('DD/MM/YYYY');
	};

	this.generateReport = function(widget, format) {
		widget.currentRow.__FORMAT = format;
		if (widget.isValid()) {
			const { currentRow } = widget;

			this.validateFilterFields(currentRow);

			if (currentRow.PAGE_BREAK == 'N' && currentRow.NMRELATORIO == "EST31100")
				currentRow.NMRELATORIO = "EST31100_noHeader";
			currentRow.NRTPARVPROD = (currentRow.hasOwnProperty('NRTPARVPROD')) ? currentRow.NRTPARVPROD : null;
			currentRow.NRARVOREPROD = (currentRow.hasOwnProperty('NRARVOREPROD')) ? currentRow.NRARVOREPROD : null;
			
			
		}
		
		this.geraRelatorio(widget);	
		
	};
	
	this.geraRelatorio = function(widget){
        var row = widget.currentRow;
        row.REPORT_NAME = row.NMRELATORIO;
        row.__report_name = row.NMRELATORIO;
        General.openReport("est_relatorios#/posicao_de_estoque", row.__report_name, row);
    };

	this.validaEstadoRangeProduto = function(widget) {
		var produtoIni = widget.getField('NMPRODUTOINI');
		var produtoFin = widget.getField('NMPRODUTOFIN');
		var tipoProduto = widget.getField('DSTPARVPROD');
		if (tipoProduto.value()) {
			produtoIni.readOnly = true;
			widget.currentRow.NMPRODUTOINI = null;
			widget.currentRow.CDARVPRODINI = null;
			widget.currentRow.CDPRODUTOINI = null;
			widget.currentRow.CDNVPRODUTOINI = null;
			produtoIni.validations = {};
			produtoFin.readOnly = true;
			produtoFin.validations = {};
			widget.currentRow.NMPRODUTOFIN = null;
			widget.currentRow.CDARVPRODFIN = null;
			widget.currentRow.CDPRODUTOFIN = null;
			widget.currentRow.CDNVPRODUTOFIN = null;
		}
		else {
			produtoIni.readOnly = false;
			produtoIni.validations = { "required": true };
			produtoFin.readOnly = false;
			produtoFin.validations = { "required": true };
		}
	};

	this.setGrupoArvore = function(widget) {
		var nmarvoreprod = widget.getField('NMARVOREPROD');
		if (widget.getField('DSTPARVPROD').value()) {
			nmarvoreprod.dataSourceFilter[0].value = widget.currentRow.NRTPARVPROD;
			nmarvoreprod.readOnly = false;
			nmarvoreprod.reload();
		}
		else {
			nmarvoreprod.dataSourceFilter[0].value = null;
			nmarvoreprod.readOnly = true;
		}
		widget.currentRow.NMTPARVORE = '';
		widget.currentRow.NMARVOREPROD = '';
		widget.currentRow.NRARVOREPROD = '';
		this.validaEstadoRangeProduto(widget);
	};

	this.validaEstadoTipoArvore = function(widget) {
		var produtoIni = widget.getField('NMPRODUTOINI');
		var produtoFin = widget.getField('NMPRODUTOFIN');
		var tipoProduto = widget.getField('DSTPARVPROD');
		var grupo = widget.getField('NMARVOREPROD');
		if (produtoIni.value() || produtoFin.value()) {
			tipoProduto.readOnly = true;
			grupo.readOnly = true;
			widget.currentRow.NRTPARVPROD = null;
			widget.currentRow.DSTPARVPROD = null;
			widget.currentRow.NMTPARVORE = null;
			widget.currentRow.NMARVOREPROD = null;
			widget.currentRow.NRARVOREPROD = null;
		}
		else {
			tipoProduto.readOnly = false;
			grupo.readOnly = false;
		}
	};

	this.requestGrupoTipoArvore = function(widget, fieldTreeProd) {
		ProdTreeGroup.getAllGroups(fieldTreeProd)
			.then(function(allGroups) {
				widget.currentRow.NRARVOREPROD = allGroups.join('_');
			})
			.catch(function(erro) {
				ScreenService.showMessage(erro.data.error);
			});
	};

	this.openGridReport = function(widget) {
		if (widget.isValid()) {
			var currentRow = widget.currentRow;
			var rowStripe = {};
			if(currentRow.NMRELATORIO == 'EST31100'|| currentRow.NMRELATORIO == 'EST31120' || currentRow.NMRELATORIO == 'EST31125'){
				rowStripe.DSFILIAL = currentRow.CDFILIAL + ' - ' + currentRow.NMFILIAL;
				rowStripe.DSPRODUTO = currentRow.CDARVPRODINI + ' à ' + currentRow.CDARVPRODFIN.replaceAll('z', '');
				rowStripe.DATAPOS = currentRow.DATAPOS;
				rowStripe.CUSTO = currentRow.NMTIPOCUSTO;
				rowStripe.CDALMOXARIFE = currentRow.CDALMOXARIFE || ' ';
				rowStripe.CDLOCALESTOQ = currentRow.CDLOCALESTOQ || ' ';
	
				localStorageEngine.setDataSource('/StripePosicao', rowStripe).then(() => {
					this.validateFilterFields(currentRow);
					ScreenService.openWindow("est_relatorios#est31100_grid_relatorio_posicao").then(() => {
						setTimeout(function() { //(Verificar a necessidade deste timeout quando convertar a tela para o filtro 3.
							let widgetGrid = templateManager.containers["est_relatorios#est31100_grid_relatorio_posicao"].getWidget('gridWidget');
							if (widgetGrid) {
								widgetGrid.dataSourceFilter = [
									{
										"name": "CDARVPRODFIN",
										"operator": "=",
										"value": currentRow.CDARVPRODFIN
									},
									{
										"name": "CDALMOXARIFE",
										"operator": "=",
										"value": currentRow.CDALMOXARIFE || ' '
									},
									{
										"name": "ORDENANOME",
										"operator": "=",
										"value": currentRow.ORDENANOME
									},
									{
										"name": "CDTIPOCUSTO",
										"operator": "=",
										"value": currentRow.CDTIPOCUSTO
									},
									{
										"name": "P_NVTOT",
										"operator": "=",
										"value": currentRow.NVTOT
									},
									{
										"name": "DTPOSICAO",
										"operator": "=",
										"value": currentRow.DTPOSICAO
									},
									{
										"name": "CDARVPRODINI",
										"operator": "=",
										"value": currentRow.CDARVPRODINI
									},
									{
										"name": "CDLOCALESTOQ",
										"operator": "=",
										"value": currentRow.CDLOCALESTOQ || ' '
									},
									{
										"name": "CDFILIAL",
										"operator": "=",
										"value": currentRow.CDFILIAL
									},
									{
										"name": "NRARVOREPROD",
										"operator": "=",
										"value": currentRow.NRARVOREPROD
									},
									{
										"name": "NRTPARVPROD",
										"operator": "=",
										"value": currentRow.NRTPARVPROD
	
									}
				        	];
	
								widgetGrid.reload();
							}
							else {
								ScreenService.showMessage('Erro ao Gerar Relatório com os Dados Informados.');
							}
						}, 1000);
					});
				});
			}
			if(currentRow.NMRELATORIO == 'EST31104'){
				rowStripe.DSFILIAL = currentRow.CDFILIAL + ' - ' + currentRow.NMFILIAL;
				rowStripe.DSPRODUTO = currentRow.CDARVPRODINI + ' à ' + currentRow.CDARVPRODFIN.replaceAll('z', '');
				rowStripe.DATAPOS = currentRow.DATAPOS;
				rowStripe.CUSTO = currentRow.NMTIPOCUSTO;
				rowStripe.CDALMOXARIFE = currentRow.CDALMOXARIFE || ' ';
				rowStripe.CDLOCALESTOQ = currentRow.CDLOCALESTOQ || ' ';
	
				localStorageEngine.setDataSource('/StripePosicao', rowStripe).then(() => {
					this.validateFilterFields(currentRow);
					ScreenService.openWindow("est_relatorios#est31104_posicao_de_estoque_reservas").then(() => {
						setTimeout(function() { //(Verificar a necessidade deste timeout quando convertar a tela para o filtro 3.
							let widgetGrid = templateManager.containers["est_relatorios#est31104_posicao_de_estoque_reservas"].getWidget('gridWidget');
							if (widgetGrid) {
								widgetGrid.dataSourceFilter = [
									{
										"name": "CDARVPRODFIN",
										"operator": "=",
										"value": currentRow.CDARVPRODFIN
									},
									{
										"name": "CDALMOXARIFE",
										"operator": "=",
										"value": currentRow.CDALMOXARIFE || ' '
									},
									{
										"name": "ORDENANOME",
										"operator": "=",
										"value": currentRow.ORDENANOME
									},
									{
										"name": "CDTIPOCUSTO",
										"operator": "=",
										"value": currentRow.CDTIPOCUSTO
									},
									{
										"name": "P_NVTOT",
										"operator": "=",
										"value": currentRow.NVTOT
									},
									{
										"name": "DTPOSICAO",
										"operator": "=",
										"value": currentRow.DTPOSICAO
									},
									{
										"name": "CDARVPRODINI",
										"operator": "=",
										"value": currentRow.CDARVPRODINI
									},
									{
										"name": "CDLOCALESTOQ",
										"operator": "=",
										"value": currentRow.CDLOCALESTOQ || ' '
									},
									{
										"name": "CDFILIAL",
										"operator": "=",
										"value": currentRow.CDFILIAL
									},
									{
										"name": "NRARVOREPROD",
										"operator": "=",
										"value": currentRow.NRARVOREPROD
									},
									{
										"name": "NRTPARVPROD",
										"operator": "=",
										"value": currentRow.NRTPARVPROD
	
									}
				        	];
	
								widgetGrid.reload();
							}
							else {
								ScreenService.showMessage('Erro ao Gerar Relatório com os Dados Informados.');
							}
						}, 1000);
					});
				});
			}
			if(currentRow.NMRELATORIO == 'EST31100CODEBAR'){
				rowStripe.DSFILIAL = currentRow.CDFILIAL + ' - ' + currentRow.NMFILIAL;
				rowStripe.DSPRODUTO = currentRow.CDARVPRODINI + ' à ' + currentRow.CDARVPRODFIN.replaceAll('z', '');
				rowStripe.DATAPOS = currentRow.DATAPOS;
				rowStripe.CUSTO = currentRow.NMTIPOCUSTO;
				rowStripe.CDALMOXARIFE = currentRow.CDALMOXARIFE || ' ';
				rowStripe.CDLOCALESTOQ = currentRow.CDLOCALESTOQ || ' ';
	
				localStorageEngine.setDataSource('/StripePosicao', rowStripe).then(() => {
					this.validateFilterFields(currentRow);
					ScreenService.openWindow("est_relatorios#est31100_posicao_de_estoque_codigo_de_barras").then(() => {
						setTimeout(function() { //(Verificar a necessidade deste timeout quando convertar a tela para o filtro 3.
							let widgetGrid = templateManager.containers["est_relatorios#est31100_posicao_de_estoque_codigo_de_barras"].getWidget('gridWidget');
							if (widgetGrid) {
								widgetGrid.dataSourceFilter = [
									{
										"name": "CDARVPRODFIN",
										"operator": "=",
										"value": currentRow.CDARVPRODFIN
									},
									{
										"name": "CDALMOXARIFE",
										"operator": "=",
										"value": currentRow.CDALMOXARIFE || ' '
									},
									{
										"name": "ORDENANOME",
										"operator": "=",
										"value": currentRow.ORDENANOME
									},
									{
										"name": "CDTIPOCUSTO",
										"operator": "=",
										"value": currentRow.CDTIPOCUSTO
									},
									{
										"name": "P_NVTOT",
										"operator": "=",
										"value": currentRow.NVTOT
									},
									{
										"name": "DTPOSICAO",
										"operator": "=",
										"value": currentRow.DTPOSICAO
									},
									{
										"name": "CDARVPRODINI",
										"operator": "=",
										"value": currentRow.CDARVPRODINI
									},
									{
										"name": "CDLOCALESTOQ",
										"operator": "=",
										"value": currentRow.CDLOCALESTOQ || ' '
									},
									{
										"name": "CDFILIAL",
										"operator": "=",
										"value": currentRow.CDFILIAL
									},
									{
										"name": "NRARVOREPROD",
										"operator": "=",
										"value": currentRow.NRARVOREPROD
									},
									{
										"name": "NRTPARVPROD",
										"operator": "=",
										"value": currentRow.NRTPARVPROD
	
									}
				        	];
	
								widgetGrid.reload();
							}
							else {
								ScreenService.showMessage('Erro ao Gerar Relatório com os Dados Informados.');
							}
						}, 1000);
					});
				});
			}
			if(currentRow.NMRELATORIO == 'EST31100CUSTO'){
				this.validateFilterFields(currentRow);
				if(!Array.isArray(currentRow.CDALMOXARIFE))
					currentRow.CDALMOXARIFE = [];
				if(!Array.isArray(currentRow.CDLOCALESTOQ))
					currentRow.CDLOCALESTOQ = [];
				currentRow.CDALMOXARIFE.push(' ');
				currentRow.CDLOCALESTOQ.push(' ');
					ScreenService.openWindow("est_relatorios#est31100_relatorio_posicao_customizavel").then(() => {
						setTimeout(function() { 
							let widgetGrid = templateManager.containers["est_relatorios#est31100_relatorio_posicao_customizavel"].getWidget('gridWidget');
							if (widgetGrid) {
								widgetGrid.dataSourceFilter = [
									{
										"name": "CDARVPRODINI",
										"operator": "=",
										"value": currentRow.CDARVPRODINI
									},
									{
										"name": "CDARVPRODFIN",
										"operator": "=",
										"value": currentRow.CDARVPRODFIN
									},
									{
										"name": "ORDENANOME",
										"operator": "=",
										"value": currentRow.ORDENANOME
									},
									{
										"name": "CDTIPOCUSTO",
										"operator": "=",
										"value": currentRow.CDTIPOCUSTO
									},
									{
										"name": "P_NVTOT",
										"operator": "=",
										"value": currentRow.NVTOT
									},
									{
										"name": "DTPOSICAO",
										"operator": "=",
										"value": currentRow.DTPOSICAO
									},
									{
										"name": "CDALMOXARIFE",
										"operator": "IN",
										"value": currentRow.CDALMOXARIFE || ' '
									},
									{
										"name": "CDLOCALESTOQ",
										"operator": "IN",
										"value": currentRow.CDLOCALESTOQ || ' '
									},
									{
										"name": "CDFILIAL",
										"operator": "IN",
										"value": currentRow.CDFILIAL
									},
									{
										"name": "NRARVOREPROD",
										"operator": "=",
										"value": currentRow.NRARVOREPROD
									},
									{
										"name": "NRTPARVPROD",
										"operator": "=",
										"value": currentRow.NRTPARVPROD
	
									}
				        	];
	
								widgetGrid.reload();
							}
							else {
								ScreenService.showMessage('Erro ao Gerar Relatório com os Dados Informados.');
							}
						}, 1000);
					});
			}
			if(currentRow.NMRELATORIO == 'EST32800'){
				rowStripe.DSFILIAL = currentRow.CDFILIAL + ' - ' + currentRow.NMFILIAL;
				rowStripe.DSPRODUTO = currentRow.CDARVPRODINI + ' à ' + currentRow.CDARVPRODFIN.replaceAll('z', '');
				rowStripe.DATAPOS = currentRow.DATAPOS;
				rowStripe.CUSTO = currentRow.NMTIPOCUSTO;
				rowStripe.CDALMOXARIFE = currentRow.CDALMOXARIFE || ' ';
				rowStripe.CDLOCALESTOQ = currentRow.CDLOCALESTOQ || ' ';
	
				localStorageEngine.setDataSource('/StripePosicao', rowStripe).then(() => {
					this.validateFilterFields(currentRow);
					ScreenService.openWindow("est_relatorios#est32800_grid_relatorio_posicao_consolidada").then(() => {
						setTimeout(function() { //(Verificar a necessidade deste timeout quando convertar a tela para o filtro 3.
							let widgetGrid = templateManager.containers["est_relatorios#est32800_grid_relatorio_posicao_consolidada"].getWidget('gridWidget');
							if (widgetGrid) {
								widgetGrid.dataSourceFilter = [
									{
										"name": "CDARVPRODFIN",
										"operator": "=",
										"value": currentRow.CDARVPRODFIN
									},
									{
										"name": "ORDENANOME",
										"operator": "=",
										"value": currentRow.ORDENANOME
									},
									{
										"name": "CDTIPOCUSTO",
										"operator": "=",
										"value": currentRow.CDTIPOCUSTO
									},
									{
										"name": "P_NVTOT",
										"operator": "=",
										"value": currentRow.NVTOT
									},
									{
										"name": "DTPOSICAO",
										"operator": "=",
										"value": currentRow.DTPOSICAO
									},
									{
										"name": "CDARVPRODINI",
										"operator": "=",
										"value": currentRow.CDARVPRODINI
									},
									{
										"name": "CDFILIAL",
										"operator": "=",
										"value": currentRow.CDFILIAL
									}
				        	];
	
								widgetGrid.reload();
							}
							else {
								ScreenService.showMessage('Erro ao Gerar Relatório com os Dados Informados.');
							}
						}, 1000);
					});
				});
			}
		}
	};

	this.onEnterRelatorio = function() {
		var container = templateManager.container;
		var stripe = container.getWidget('stripe');
		localStorageEngine.getDataSource('/StripePosicao').then(function(row) {
			stripe.currentRow.DSFILIAL = row[0].DSFILIAL;
			stripe.currentRow.DATAPOS = row[0].DATAPOS;
			stripe.currentRow.DSPRODUTO = row[0].DSPRODUTO;
			stripe.currentRow.CUSTO = row[0].CUSTO;
			stripe.currentRow.CDALMOXARIFE = row[0].CDALMOXARIFE;
			stripe.currentRow.CDLOCALESTOQ = row[0].CDLOCALESTOQ;
		});
	};

	this.defineIdiomaTipoCusto = function(widget) {
		// setLocalVar('language', 'en_us');
		var idioma = getLocalVar('language');
		var nomeField = null;

		if (idioma == 'pt_br')
			nomeField = 'NMTIPOCUSTO';
		else if (idioma == 'en_us')
			nomeField = 'NMTIPOCUSING';
		else if (idioma == 'es_es' || idioma == 'es_cl')
			nomeField = 'NMTIPOCUSESP';

		var fields = widget.getField('NMTIPOCUSTO').fields;

		fields.forEach(function(field) {
			if (field.name == nomeField || field.name == 'CDTIPOCUSTO')
				field.isVisible = true;
			else
				field.isVisible = false;
		});

		widget.getField('NMTIPOCUSTO').displayedFields[1] = nomeField;
		widget.getField('NMTIPOCUSTO').searchableFields[1] = nomeField;
		delete widget.getField('NMTIPOCUSTO').outData.NMTIPOCUSTO;
		widget.getField('NMTIPOCUSTO').outData[nomeField] = "NMTIPOCUSTO";

		widget.getField('NMTIPOCUSTO').reload();

		this.getFilialLogada().then(function(success) {
			widget.currentRow.CDTIPOCUSTO = success.dataset.filial_paramfilial_tipocusto[0].CDTIPOCUSTO;
			widget.currentRow.NMTIPOCUSTO = success.dataset.filial_paramfilial_tipocusto[0][nomeField];
		});
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Est31100_PosicaoDeEstoque_Controller', Est31100_PosicaoDeEstoque_Controller);
});
