package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.TransferenciaDeEstoqueFlows;
import com.javaseleniumtemplate.pages.TransferenciaDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class TransferenciaDeEstoqueTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    TransferenciaDeEstoqueFlows transferenciaDeEstoqueFlows;
    TransferenciaDeEstoquePage transferenciaDeEstoquePage;

    @Test(priority = 1,description = "Est-14")
    @Ignore
    public void RealizarTransferenciaDeEstoque(){
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        transferenciaDeEstoqueFlows = new TransferenciaDeEstoqueFlows();
        transferenciaDeEstoquePage = new TransferenciaDeEstoquePage();


        //Parameteres_Lançamento
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String almoxarifadoOrigem = "HELA MATRIZ";
        String almoxaridfadoDestino = "HELA LOJA";
        String campoProduto = "Hela Poultry Broth Paste Clear KG";
        String campoLote = "00231100";
        String campoQuantidade = "1";




        //Rotine:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoTransferenciaDeEstoque();
        transferenciaDeEstoqueFlows.preencherFiltroTransferenciaDeEstoque(descUnidade, almoxarifadoOrigem,almoxaridfadoDestino);
        transferenciaDeEstoqueFlows.realizarTransferenciaDeEstoque(campoProduto,campoLote, campoQuantidade);

    }


    @Test(priority = 2,description = "Est-15")
    @Ignore
    public void EditarTransferenciaDeEstoque(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        transferenciaDeEstoqueFlows = new TransferenciaDeEstoqueFlows();
        transferenciaDeEstoquePage = new TransferenciaDeEstoquePage();


        //Parameteres_Lançamento
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String almoxarifadoOrigem = "HELA MATRIZ";
        String almoxarifadoDestino = "HELA LOJA";
        String campoProduto = "Hela Poultry Broth Paste Clear KG";
        String campoLoteEditado = "00231100";
        String campoQuantidadeEditado = "1";
        String campoProdutoEditado = "Hela Ox Bouillon Paste Clear KG";

        //Rotine
        loginFlows.efetuarLogin();

        mainFlows.AcessandoTransferenciaDeEstoque();
        transferenciaDeEstoqueFlows.preencherFiltroTransferenciaDeEstoque(descUnidade,almoxarifadoOrigem,almoxarifadoDestino);
        transferenciaDeEstoqueFlows.editarTransferenciaDeEstoque(campoProduto,campoProdutoEditado,campoLoteEditado, campoQuantidadeEditado);


    }

    @Test(priority = 3,description = "Est-16")
    @Ignore
    public void ExcluirTransferenciaDeEstoque(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        transferenciaDeEstoqueFlows = new TransferenciaDeEstoqueFlows();
        transferenciaDeEstoquePage = new TransferenciaDeEstoquePage();



        //Parameteres_Lançamento
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String almoxarifadoOrigem = "HELA MATRIZ";
        String almoxaridfadoDestino = "HELA LOJA";
        String campoProduto = "Hela Poultry Broth Paste Clear KG";


        //Rotine:
        loginFlows.efetuarLogin();
        // mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoTransferenciaDeEstoque();
        transferenciaDeEstoqueFlows.preencherFiltroTransferenciaDeEstoque(descUnidade,almoxarifadoOrigem,almoxaridfadoDestino);
        transferenciaDeEstoqueFlows.excluirTransferenciaDeEstoque();

    }

}