package com.javaseleniumtemplate.tests.semLote;


import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.semLote.EntradaDeEstoqueSemLoteFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.semLote.EntradaDeEstoqueSemLotePage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;

public class EntradaDeEstoqueSemLoteTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    EntradaDeEstoqueSemLoteFlows entradaDeEstoqueSemLoteFlows;
    EntradaDeEstoqueSemLotePage entradaDeEstoqueSemLotePage;


    @Test(description = "Est-35")
    @Ignore

    public void EfetuarEntradaDeEstoqueNaoControlaLote() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueSemLoteFlows = new EntradaDeEstoqueSemLoteFlows();
        entradaDeEstoqueSemLotePage = new EntradaDeEstoqueSemLotePage();

        //Parameteres_login:

        //Parameteres_Lançamento:
        String quantidade = "3";
        String cmpDesc = "Teste Automatizado";
        String descProduto = "SUMO DE LIMAO - CX12 500ML";
        String descAlmoxarifado = "HELA MATRIZ";
        String DescCampoLote = "025/50";
        String descUnidade = "HELA Nao Controla Lote";
        String valorUnitario = "1,2";
        String valorEstoqueEsperado = "18";
        String valorTotalEstoqueEsperado = "18";
        String valorUnitarioLancado = "1.2";


        //Rotinas:
        loginFlows.efetuarLogin();
      //  mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoEntradaDeEstoque();
        entradaDeEstoqueSemLoteFlows.aplicarFiltro(descUnidade, descAlmoxarifado);
        entradaDeEstoqueSemLoteFlows.AdicionarEntradaEstoque(cmpDesc, descProduto, quantidade, descAlmoxarifado, DescCampoLote, valorUnitario);

        //Banco

        String numeroLancamento = entradaDeEstoqueSemLotePage.retornaNumeroLacamento();
        Assert.assertTrue(DBSteps.retornaQuatidadeEstoque(numeroLancamento).contains(valorEstoqueEsperado));
        String valorLancamentoTotalEstoque = entradaDeEstoqueSemLotePage.retornaNumeroLacamento();
        Assert.assertTrue(DBSteps.retornaValorTotalQuantidadeEstoque(valorLancamentoTotalEstoque).contains(valorTotalEstoqueEsperado));
        Assert.assertEquals(numeroLancamento, valorLancamentoTotalEstoque, "comparação entre o valor lançado e o valor que tem em estoque");
        Assert.assertTrue(DBSteps.retornaValorUnitarioLancadoEstoque(numeroLancamento).contains(valorUnitarioLancado));//verifica o valor lançado no banco do valor unitario



    }

    @Test(description = "Est-36")
    @Ignore
    public void EditarEntradaEstoqueNaoControlaLote() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueSemLoteFlows = new EntradaDeEstoqueSemLoteFlows();
        entradaDeEstoqueSemLotePage = new EntradaDeEstoqueSemLotePage();


        //Parameteres_Editar

        String cmpDesc2 = "Deletar";
        String cmpProduto = "Hela Poultry Broth Paste Clear KG";
        String quantidadeEditado = "3";
        String valorEditado = "1.5";
        String valorUnitario = "1,2";
        String valorEstoqueEsperado = "18";
        String valorTotalEstoqueEsperado = "18";
        String valorUnitarioLancado = "1.2";


        //Rotinas:
        loginFlows.efetuarLogin();
       // mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoEntradaDeEstoque();
        //entradaDeEstoqueSemLoteFlows.aplicarFiltro(descUnidade,descAlmoxarifado);
        entradaDeEstoqueSemLoteFlows.EditarEntradaEstoque(cmpDesc2, cmpProduto, valorEditado, quantidadeEditado);





    }

    @Test(description = "Est-37")
    @Ignore
    public void ExcluirEntradaDeEstoqueNaoControlaLote() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        entradaDeEstoqueSemLoteFlows = new EntradaDeEstoqueSemLoteFlows();
        entradaDeEstoqueSemLotePage = new EntradaDeEstoqueSemLotePage();


        //Rotinas:
        loginFlows.efetuarLogin();
       // mainFlows.AcessandoTrocaUnidadeNaoControlaLote();
        mainFlows.AcessandoEntradaDeEstoque();
        entradaDeEstoqueSemLoteFlows.ExcluirEntradaDeEstoque();
    }
}






